Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.math3.analysis.polynomials
Class PolynomialSplineFunction

    java.lang.Object
      org.apache.commons.math3.analysis.polynomials.PolynomialSplineFunction

All Implemented Interfaces:
  DifferentiableUnivariateFunction, UnivariateDifferentiableFunction, UnivariateFunction

    public class PolynomialSplineFunction

extends Object
implements UnivariateDifferentiableFunction, DifferentiableUnivariateFunction

Represents a polynomial spline function.

A polynomial spline function consists of a set of interpolating polynomials and an ascending array of domain knot points, determining the intervals over which the spline function is defined by the constituent polynomials. The polynomials are assumed to have been computed to match the values of another function at the knot points. The value consistency constraints are not currently enforced by `PolynomialSplineFunction` itself, but are assumed to hold among the polynomials and knot points passed to the constructor.

N.B.: The polynomials in the `polynomials` property must be centered on the knot points to compute the spline function values. See below.

The domain of the polynomial spline function is `[smallest knot, largest knot]`. Attempts to evaluate the function at values outside of this range generate IllegalArgumentExceptions.

The value of the polynomial spline function for an argument `x` is computed as follows:

1. The knot array is searched to find the segment to which `x` belongs. If `x` is less than the smallest knot point or greater than the largest one, an `IllegalArgumentException` is thrown.
2. Let `j` be the index of the largest knot point that is less than or equal to `x`. The value returned is
   `polynomials[j](x - knot[j])`

Version:
  $Id: PolynomialSplineFunction.java 1383441 2012-09-11 14:56:39Z luc $

Constructor Summary
`PolynomialSplineFunction(double[] knots, PolynomialFunction[] polynomials)` Construct a polynomial spline function with the given segment delimiters and interpolating polynomials.

Method Summary
`UnivariateFunction` | `derivative()` Get the derivative of the polynomial spline function.
`double[]` | `getKnots()` Get an array copy of the knot points.
`int` | `getN()` Get the number of spline segments.
`PolynomialFunction[]` | `getPolynomials()` Get a copy of the interpolating polynomials array.
`PolynomialSplineFunction` | `polynomialSplineDerivative()` Get the derivative of the polynomial spline function.
`DerivativeStructure` | `value(DerivativeStructure t)` Simple mathematical function.
`double` | `value(double v)` Compute the value for the function.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### PolynomialSplineFunction

    public PolynomialSplineFunction(double[] knots,
                                    PolynomialFunction[] polynomials)

  Construct a polynomial spline function with the given segment delimiters and interpolating polynomials. The constructor copies both arrays and assigns the copies to the knots and polynomials properties, respectively.

  Parameters:
    `knots` - Spline segment interval delimiters.
    `polynomials` - Polynomial functions that make up the spline.
  Throws:
    `NullArgumentException` - if either of the input arrays is `null`.
    `NumberIsTooSmallException` - if knots has length less than 2.
    `DimensionMismatchException` - if `polynomials.length != knots.length - 1`.
    `NonMonotonicSequenceException` - if the `knots` array is not strictly increasing.

Method Detail

### value

    public double value(double v)

  Compute the value for the function. See `PolynomialSplineFunction` for details on the algorithm for computing the value of the function.

  Specified by:
    `value` in interface `UnivariateFunction`
  Parameters:
    `v` - Point for which the function value should be computed.
  Returns:
    the value.
  Throws:
    `OutOfRangeException` - if `v` is outside of the domain of the spline function (smaller than the smallest knot point or larger than the largest knot point).

### derivative

    public UnivariateFunction derivative()

  Get the derivative of the polynomial spline function.

  Specified by:
    `derivative` in interface `DifferentiableUnivariateFunction`
  Returns:
    the derivative function.

### polynomialSplineDerivative

    public PolynomialSplineFunction polynomialSplineDerivative()

  Get the derivative of the polynomial spline function.

  Returns:
    the derivative function.

### value

    public DerivativeStructure value(DerivativeStructure t)

  Simple mathematical function.

  `UnivariateDifferentiableFunction` classes compute both the value and the first derivative of the function.

  Specified by:
    `value` in interface `UnivariateDifferentiableFunction`
  Parameters:
    `t` - function input value
  Returns:
    function result
  Since:
    3.1

### getN

    public int getN()

  Get the number of spline segments. It is also the number of polynomials and the number of knot points - 1.

  Returns:
    the number of spline segments.

### getPolynomials

    public PolynomialFunction[] getPolynomials()

  Get a copy of the interpolating polynomials array. It returns a fresh copy of the array. Changes made to the copy will not affect the polynomials property.

  Returns:
    the interpolating polynomials.

### getKnots

    public double[] getKnots()

  Get an array copy of the knot points. It returns a fresh copy of the array. Changes made to the copy will not affect the knots property.

  Returns:
    the knot points.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2003-2013 The Apache Software Foundation. All Rights Reserved.